Scala Compiler2.13.0 < Back


# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package backend
  Definition Classes
    nsc
-  package jvm
  Definition Classes
    backend
-  package opt
  Definition Classes
    jvm
- BoxUnbox
- ByteCodeRepository
- BytecodeUtils
- CallGraph
- ClosureOptimizer
- CopyProp
- InlineInfoAttribute
- InlineInfoAttributePrototype
- Inliner
- InlinerHeuristics
- LabelNotLive
- LocalOpt
- LocalOptImpls
- LruMap
- RemovePair
- RemovePairDependency

c

scala.tools.nsc.backend.jvm.opt

# Inliner

###

#### abstract class Inliner extends AnyRef

Source
  Inliner.scala

Linear Supertypes
AnyRef, Any
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Inliner
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1.  new Inliner()

### Type Members

1.  final class InlineLog extends AnyRef
2.  final case class InlinedCallsite(eliminatedCallsite: (callGraph)#Callsite, warning: Option[IllegalAccessInstructions]) extends Product with Serializable
3.  final class MethodInlinerState extends AnyRef
4.  class UndoLog extends AnyRef

### Abstract Value Members

1.  abstract val postProcessor: PostProcessor

### Concrete Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from Inliner toany2stringadd[Inliner] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (Inliner, B)
   Implicit
     This member is added by an implicit conversion from Inliner toArrowAssoc[Inliner] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  val NoUndoLogging: UndoLog
7.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
8.  def canInlineCallsite(callsite: (callGraph)#Callsite): Option[CannotInlineWarning]

   Check whether the body of the callee contains any instructions that prevent the callsite from being inlined.

   Check whether the body of the callee contains any instructions that prevent the callsite from being inlined. See also method `earlyCanInlineCheck`.

   The result of this check depends on changes to the callee method's body. For example, if the callee initially invokes a private method, it cannot be inlined into a different class. If the private method is inlined into the callee, inlining the callee becomes possible. Therefore we don't query it while traversing the call graph and selecting callsites to inline - it might rule out callsites that can be inlined just fine.

   Returns

   - `None` if the callsite can be inlined
   - `Some((message, Nil))` if there was an issue performing the access checks, for example because of a missing classfile
   - `Some((message, instructions))` if inlining `instructions` into the callsite method would cause an IllegalAccessError
9.  final def classIsAccessible(accessed: BType, from: ClassBType): Either[OptimizerWarning, Boolean]

   Check if a type is accessible to some class, as defined in JVMS 5.4.4.

   Check if a type is accessible to some class, as defined in JVMS 5.4.4. (A1) C is public (A2) C and D are members of the same run-time package

   Annotations
     @tailrec()
10.  def clone(): AnyRef
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.CloneNotSupportedException]) @native()
11.  def earlyCanInlineCheck(callsite: (callGraph)#Callsite): Option[CannotInlineWarning]

    Check whether an inlining can be performed.

    Check whether an inlining can be performed. This method performs tests that don't change even if the body of the callee is changed by the inliner / optimizer, so it can be used early (when looking at the call graph and collecting inline requests for the program).

    The tests that inspect the callee's instructions are implemented in method `canInlineBody`, which is queried when performing an inline.

    returns

      `Some(message)` if inlining cannot be performed, `None` otherwise

12.  def ensuring(cond: (Inliner) => Boolean, msg: => Any): Inliner
    Implicit
      This member is added by an implicit conversion from Inliner toEnsuring[Inliner] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
13.  def ensuring(cond: (Inliner) => Boolean): Inliner
    Implicit
      This member is added by an implicit conversion from Inliner toEnsuring[Inliner] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
14.  def ensuring(cond: Boolean, msg: => Any): Inliner
    Implicit
      This member is added by an implicit conversion from Inliner toEnsuring[Inliner] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
15.  def ensuring(cond: Boolean): Inliner
    Implicit
      This member is added by an implicit conversion from Inliner toEnsuring[Inliner] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
16.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
17.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
18.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
19.  def findIllegalAccess(instructions: InsnList, calleeDeclarationClass: ClassBType, destinationClass: ClassBType): Either[(AbstractInsnNode, OptimizerWarning), List[AbstractInsnNode]]

    Returns

    Returns

    - `Right(Nil)` if all instructions can be safely inlined
    - `Right(insns)` if inlining any of `insns` would cause a java.lang.IllegalAccessError when inlined into the `destinationClass`
    - `Left((insn, warning))` if validity of some instruction could not be checked because an error occurred
20.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from Inliner toStringFormat[Inliner] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
21.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
22.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
23.  def inlineCallsite(callsite: (callGraph)#Callsite, aliasFrame: Option[AliasingFrame[Value]] = None, updateCallGraph: Boolean = true): Map[AbstractInsnNode, AbstractInsnNode]

    Copy and adapt the instructions of a method to a callsite.

    Copy and adapt the instructions of a method to a callsite.

    Preconditions:

    - The callsite can safely be inlined (canInlineBody is true)
    - The maxLocals and maxStack values of the callsite method are correctly computed
    returns

      A map associating instruction nodes of the callee with the corresponding cloned instruction in the callsite method.

24.  val inlineRequestOrdering: math.Ordering[(inlinerHeuristics)#InlineRequest]
25.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
26.  def maybeInlinedLater(callsite: (callGraph)#Callsite, insns: List[AbstractInsnNode]): Boolean
27.  def memberIsAccessible(memberFlags: Int, memberDeclClass: ClassBType, memberRefClass: ClassBType, from: ClassBType): Either[OptimizerWarning, Boolean]

    Check if a member reference is accessible from the destinationClass, as defined in the JVMS 5.4.4.

    Check if a member reference is accessible from the destinationClass, as defined in the JVMS 5.4.4. Note that the class name in a field / method reference is not necessarily the class in which the member is declared:

    class A { def f = 0 }; class B extends A { f }

    The INVOKEVIRTUAL instruction uses a method reference "B.f ()I". Therefore this method has two parameters:

    memberDeclClass

      The class in which the member is declared (A)

    memberRefClass

      The class used in the member reference (B) (B0) JVMS 5.4.3.2 / 5.4.3.3: when resolving a member of class C in D, the class C is resolved first. According to 5.4.3.1, this requires C to be accessible in D. JVMS 5.4.4 summary: A field or method R is accessible to a class D (destinationClass) iff (B1) R is public (B2) R is protected, declared in C (memberDeclClass) and D is a subclass of C. If R is not static, R must contain a symbolic reference to a class T (memberRefClass), such that T is either a subclass of D, a superclass of D, or D itself. Also (P) needs to be satisfied. (B3) R is either protected or has default access and declared by a class in the same run-time package as D. If R is protected, also (P) needs to be satisfied. (B4) R is private and is declared in D. (P) When accessing a protected instance member, the target object on the stack (the receiver) has to be a subtype of D (destinationClass). This is enforced by classfile verification (https://docs.oracle.com/javase/specs/jvms/se8/html/jvms-4.html#jvms-4.10.1.8). TODO: we cannot currently implement (P) because we don't have the necessary information available. Once we have a type propagation analysis implemented, we can extract the receiver type from there (https://github.com/scala-opt/scala/issues/13).

28.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
29.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
30.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
31.  def runInliner(methods: Option[LinkedHashSet[MethodNode]], inlinerState: Map[MethodNode, MethodInlinerState], failed: Set[MethodInsnNode]): Iterable[MethodNode]

    methods

      The methods to check for callsites to inline. If not defined, check all methods.

    returns

      The set of changed methods, in no deterministic order.

32.  def runInlinerAndClosureOptimizer(): Unit
33.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
34.  def toString(): String
    Definition Classes
      AnyRef → Any
35.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
36.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
37.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()
38.  object InlineLog
39.  object callsiteOrdering extends Ordering[(callGraph)#Callsite]

    Ordering for inline requests.

    Ordering for inline requests. Required to make the inliner deterministic:

    - Always remove the same request when breaking inlining cycles
    - Perform inlinings in a consistent order

### Deprecated Value Members

1.  def →[B](y: B): (Inliner, B)
   Implicit
     This member is added by an implicit conversion from Inliner toArrowAssoc[Inliner] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromInliner to any2stringadd[Inliner]

### Inherited by implicit conversion StringFormat fromInliner to StringFormat[Inliner]

### Inherited by implicit conversion Ensuring fromInliner to Ensuring[Inliner]

### Inherited by implicit conversion ArrowAssoc fromInliner to ArrowAssoc[Inliner]

### Ungrouped